var events = require('events');
var express = require('express');
var path = require('path');

function Server (options) {
	options = options || {};
	this.port = options.port || 3001;
	this.env = options.env || 'development';
	this.app = express();
	this.configure();
}

Server.prototype = Object.create(events.EventEmitter.prototype);

Server.prototype.configure = function () {
	var app = this.app;

	app.configure(function () {
		app.use(express.static(__dirname + '/tests'));
		app.use(express.bodyParser());
		app.use(app.router);
	});

	app.get('/eta.js', function (req, res) {
		res.sendfile(path.resolve('eta.js'));
	});
};

Server.prototype.start = function () {
	var server = this;
	this.app.listen(this.port, function () {
		server.emit('listening', server.port, server.env);
	});
};

module.exports = Server;
