ETA.ajaxConverter('postmessage xml', function (p) { return p; });
ETA.ajaxConverter('postmessage text', function (p) { return p; });
ETA.ajaxConverter('postmessage json', function (p) { return p; });

ETA.ajaxTransport('postmessage', function (options) {
	if (!ETA.features.cors && ETA.features.postMessage && options && options.postMessage) {
		var iframe;
		var target = ETA.utils.getTarget(options.postMessage);
		return {
			send: function (headers, complete) {
				var message = {
					id: ETA.utils.uuid()
				};

				function onMessage (e) {
					try {
						var data = JSON.parse(e.data);
						if (data && data.id === message.id) {
							complete(data.status, data.statusText, data.result, data.headers);
							iframe.parentNode.removeChild(iframe);
							ETA.DOM.removeEventListener('message', window, onMessage);
						}
					} catch (err) {
					}
				}

				iframe = document.createElement('iframe');
				iframe.src = options.postMessage;
				iframe.style.display = 'none';
				ETA.DOM.addEventListener('load', iframe, function () {
					var win = iframe.contentWindow || iframe.contentDocument.parentWindow;
					for (var key in options) message[key] = options[key];
					message.dataType = message.dataType.replace('postmessage ', '');
					ETA.DOM.addEventListener('message', window, onMessage);
					win.postMessage(JSON.stringify(message), target);
				});
				document.body.appendChild(iframe);
			},
			abort: function () {
				if (iframe) {
					iframe.parentNode.removeChild(iframe);
				}
			}
		};
	}
});
