ETA.ajaxTransport('xhr', function (options) {
	var callback;
	if (ETA.features.cors && options) {
		return {
			send: function (headers, complete) {
				var xhr = new XMLHttpRequest();
				xhr.open(options.type, options.url, options.async);

				// Set headers.
				try {
					for (var header in headers) {
						xhr.setRequestHeader(header, headers[header]);
					}
				} catch (err) {}

				// Callback.
				callback = function (type) {
					return function () {
						if (callback) {
							callback = xhr.onload = xhr.onerror = null;
							if (type === 'abort') {
								xhr.abort();
							} else if (type === 'error') {
								complete(xhr.status || 404, xhr.statusText);
							} else {
								complete(
									xhr.status,
									xhr.statusText,
									xhr.responseText,
									xhr.getAllResponseHeaders()
								);
							}
						}
					};
				};

				// Listen to events.
				xhr.onload = callback();
				xhr.onerror = callback('error');
				xhr.send((options.hasContent && options.data) || null);
			},
			abort: function () {
				if (callback) {
					callback('abort')();
				}
			}
		};
	}
});
