ETA.DOM = {};

// Cross-browser add event listener.
//
// @param		String			eventName		The event name
// @param		Object			element			The DOM element
// @param		Function		callback		The callback
ETA.DOM.addEventListener =  function (eventName, element, callback) {
	if (element.addEventListener) {
		element.addEventListener(eventName, callback, false);
	} else if (element.attachEvent) {
		element.attachEvent('on' + eventName, callback);
	}
};

// Cross-browser remove event listener.
//
// @param		String			eventName		The event name
// @param		Object			element			The DOM element
// @param		Function		callback		The callback
ETA.DOM.removeEventListener =  function (eventName, element, callback) {
	if (element.removeEventListener) {
		element.removeEventListener(eventName, callback, false);
	} else if (element.detachEvent) {
		element.detachEvent('on' + eventName, callback);
	}
};
