// Determine browser features.
ETA.features = {};

ETA.features.localStorage = 'localStorage' in window;
ETA.features.sessionStorage = 'sessionStorage' in window;
ETA.features.geolocation = 'geolocation' in navigator;
ETA.features.postMessage = !!window.postMessage;
ETA.features.formData = !!window.FormData;
ETA.features.cors = (function () {
	try {
		var ua = navigator.userAgent;
		var v;
		var xhr;

		// Certain Android versions have a buggy Android implementation.
		// http://www.kinvey.com/blog/107/how-to-build-a-service-that-supports-every-android-browser
		if (/android/gi.test(ua)) {
			v = parseFloat(ua.slice(ua.indexOf('Android') + 8));
			if (v === 2.1 || v == 2.2 || v === 2.3 || v === 3.2) {
				return false;
			}
		}
		xhr = new window.XMLHttpRequest();
		return 'withCredentials' in xhr;
	} catch (err) {
		return false;
	}
})();
ETA.features.fileAPI = (function () {
	var input = document.createElement('input');
	input.type = 'file';
	return 'files' in input;
})();

ETA.features.ajaxUploadWithProgress = ETA.features.fileAPI && ETA.features.ajaxUploadProgressEvent && ETA.features.formData;

if (DEBUG) {
	console.log('ETA.features', ETA.features);
}
