test('ETA.Client - new', function () {
	var eta = new ETA.Client({
		apiKey: 'test-api-key',
		apiSecret: 'test-api-secret',
		apiURL: 'http://example.com',
		apiPostMessageURL: 'http://example.com/postmessage',
		proxyURL: 'http://example.com/proxy/',
		locale: 'en_US',
		storageEnabled: false
	});

	strictEqual(eta.apiKey, 'test-api-key');
	strictEqual(eta.apiSecret, 'test-api-secret');
	strictEqual(eta.apiURL, 'http://example.com');
	strictEqual(eta.apiPostMessageURL, 'http://example.com/postmessage');
	strictEqual(eta.proxyURL, 'http://example.com/proxy/?locale=en_US');
	strictEqual(eta.locale, 'en_US');
	strictEqual(eta.storageEnabled, false);
});

test('ETA.Client - allowStorageForKey', function () {
	var eta1 = new ETA.Client({ apiKey: 'test-api-key' });
	var eta2 = new ETA.Client({ apiKey: 'test-api-key', storageEnabled: false });
	var eta3 = new ETA.Client({ apiKey: 'test-api-key', storageEnabled: ['somePrefix'] });

	strictEqual(eta1.allowStorageForKey('test'), true);
	strictEqual(eta2.allowStorageForKey('test'), false);
	strictEqual(eta3.allowStorageForKey('somePrefix.test'), true);
	strictEqual(eta3.allowStorageForKey('someOtherPrefix.test'), false);
});

asyncTest('ETA.Client - initialize', function () {
	expect(1);
	var client = ETAUnit.getClient();
	client.initialize(function (err) {
		ok(!err);
		start();
	});
});
