test('ETA.Dispatcher - addEventListener', function () {
	var dispatcher = {};
	
	ETA.Dispatcher.mixin(dispatcher);
	dispatcher.addEventListener('test', function () {});
	ok(!!dispatcher._events.test);
});

test('ETA.Dispatcher - addEventListener/multiple', function () {
	expect(2);
	var dispatcher = {};

	ETA.Dispatcher.mixin(dispatcher);
	dispatcher.addEventListener('test1 test2', function () {});
	ok(!!dispatcher._events.test1);
	ok(!!dispatcher._events.test2);
});

test('ETA.Dispatcher - addEventListener/all', function () {
	expect(2);
	var dispatcher = {};

	ETA.Dispatcher.mixin(dispatcher);
	dispatcher.addEventListener('all', function () {
		ok(true);
	});
	dispatcher.dispatch('test1');
	dispatcher.dispatch('test2');
});

test('ETA.Dispatcher - removeEventListener', function () {
	var dispatcher = {};
	var callback = function () {};

	ETA.Dispatcher.mixin(dispatcher);
	dispatcher.addEventListener('test', callback);
	dispatcher.removeEventListener('test', callback);
	strictEqual(dispatcher._events.test.length, 0);
});

test('ETA.Dispatcher - dispatch', function () {
	expect(2);
	var dispatcher = {};
	var firstInput = {
		x: 1,
		y: 1,
		z: {
			x: 2,
			y: 2
		}
	};
	var secondInput = 1;

	ETA.Dispatcher.mixin(dispatcher);
	dispatcher.addEventListener('test', function (first, second) {
		deepEqual(firstInput, first);
		strictEqual(secondInput, second);
	});
	dispatcher.dispatch('test', firstInput, secondInput);
})
